<?php 
/*** COPYRIGHT NOTICE *********************************************************
 *
 * Copyright 2009-2017 ProjeQtOr - Pascal BERNARD - support@projeqtor.org
 * Contributors : -
 *
 * This file is part of ProjeQtOr.
 * 
 * ProjeQtOr is free software: you can redistribute it and/or modify it under 
 * the terms of the GNU Affero General Public License as published by the Free 
 * Software Foundation, either version 3 of the License, or (at your option) 
 * any later version.
 * 
 * ProjeQtOr is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for 
 * more details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * ProjeQtOr. If not, see <http://www.gnu.org/licenses/>.
 *
 * You can get complete code of ProjeQtOr, other resource, help and information
 * about contributors at http://www.projeqtor.org 
 *     
 *** DO NOT REMOVE THIS NOTICE ************************************************/

/** ============================================================================
 * Project is the main object of the project managmement.
 * Almost all other objects are linked to a given project.
 */ 
require_once('_securityCheck.php');
class Project extends ProjectMain {

public $_sec_Description;
public $id;
public $_spe_rf;
public $name;
public $idProjectType;
public $idOrganization;
public $organizationInherited;
public $organizationElementary;
public $idCategory;
public $codeType;
public $idClient;
public $idContact;
public $projectCode;
public $contractCode;
public $clientCode;
public $idProject;
public $idCommercial;
public $idSponsor;
public $idResource;
public $penalite;
public $atex;
public $isUnderConstruction;
public $suivideprojet;
public $idUser;
public $creationDate;
public $color;
public $idStatus;
public $idHealth;
public $idQuality;
public $idTrend;
public $idOverallProgress;
public $fixPlanning;
public $done;
public $doneDate;
public $idle;
public $idleDate;
public $cancelled;
public $_lib_cancelled;
public $longitude;
public $latitude;
public $description;
public $objectives;
public $_sec_Progress;
public $ProjectPlanningElement;
public $_sec_Affectations;
public $_spe_affectations;
public $_sec_ProductprojectProducts;
public $_ProductProject=array();
public $_sec_VersionprojectVersions;
public $_VersionProject=array();
public $_sec_Subprojects;
public $_spe_subprojects;
public $_sec_predecessor;
public $_Dependency_Predecessor=array();
public $_sec_successor;
public $_Dependency_Successor=array();
public $_sec_restrictTypes;
public $_spe_restrictTypes;
public $_sec_Link;
public $_Link=array();
public $_Attachment=array();
public $_Note=array();
public $sortOrder;
public $lastUpdateDateTime;
public $_nbColMax=3;


public static $_customFields=array(
'suivideprojet'
,'idCommercial'
,'penalite'
,'atex'
);

public static $_colCaptionTransposition=array(
"suivideprojet"=>"plgSuivideprojet",
"idCommercial"=>"plgIdCommercial",
"penalite"=>"plgPenalite",
"atex"=>"plgAtex"
);

private static $_fieldsAttributes=array(
"name"=>"required",
"done"=>"nobr",
"idle"=>"nobr",
"sortOrder"=>"hidden",
"codeType"=>"hidden",
"idProjectType"=>"required",
"longitude"=>"hidden",
"latitude"=>"hidden",
"idStatus"=>"required",
"idleDate"=>"nobr",
"cancelled"=>"nobr",
"clientCode"=>"hidden",
"idSponsor"=>"hidden",
"contractCode"=>"required",
"idContact"=>"hidden",
"idHealth"=>"hidden",
"idQuality"=>"hidden",
"idTrend"=>"hidden",
"fixPlanning"=>"",
"description"=>"required",
"projectCode"=>"required",
"suivideprojet"=>"",
"objectives"=>"hidden",
"commercial"=>"",
"idCommercial"=>"required",
"isUnderConstruction"=>"",
"penalite"=>"",
"atex"=>"",
"organizationInherited"=>"hidden",
"organizationElementary"=>"hidden	"
);

/** ==========================================================================
* Constructor
* @param $id the id of the object in the database (null if not stored yet)
* @return void
*/
function __construct($id = NULL, $withoutDependentObjects=false) {
parent::__construct($id,$withoutDependentObjects);
}

/** ==========================================================================
* Destructor
* @return void
*/
function __destruct() {
parent::__destruct();
}



/** ==========================================================================
* Return the specific fieldsAttributes
* @return the fieldsAttributes
*/
protected function getStaticFieldsAttributes() {
return array_merge(parent::getStaticFieldsAttributes(),self::$_fieldsAttributes);
}

/** ============================================================================
* Return the specific colCaptionTransposition
* @return the colCaptionTransposition
*/
protected function getStaticColCaptionTransposition($fld=null) {
if (isset(self::$_colCaptionTransposition)) {
return array_merge(parent::getStaticColCaptionTransposition($fld),self::$_colCaptionTransposition);
} else {
return parent::getStaticColCaptionTransposition($fld);
}
}
}
?>